'use server';
import { NextResponse } from 'next/server';
import { GraphQLClient, gql } from 'graphql-request';

const endpoint = "http://localhost:3001/graphql";

export async function POST(request: Request) {
    const body = await request.json();
    const { limit, skip, sort, filters, buildID } = body;
    try {
        const client = new GraphQLClient(endpoint);
        const query = gql`
            query GetLivingSpaces($input: ListArguments!, $buildID: String!) {
                getLivingSpaces(input: $input, buildID: $buildID) {
                    data {
                        _id
                        uuid
                        build
                        part
                        userType
                        company
                        person
                        isNotificationSend
                        expiryEnds
                        expiryStarts
                        createdAt
                        updatedAt
                        isConfirmed
                        deleted
                        
                    }
                    totalCount
                }
            }
        `;
        const variables = { input: { limit, skip, sort, filters }, buildID };
        const data = await client.request(query, variables);
        return NextResponse.json({ data: data.getLivingSpaces.data, totalCount: data.getLivingSpaces.totalCount });
    } catch (err: any) {
        console.error(err);
        return NextResponse.json({ error: err.message }, { status: 500 });
    }
}
